import type { AnyExtension, EditorStateProps, RemirrorManager, Shape } from '@remirror/core';
export interface RemirrorSSRProps<Extension extends AnyExtension> extends EditorStateProps {
    /**
     * The attributes to pass into the root div element.
     */
    attributes: Shape;
    /**
     * Whether or not the editor is in an editable state
     */
    editable: boolean;
    /**
     * The manager.
     */
    manager: RemirrorManager<Extension>;
}
/**
 * Remirror SSR component used for rendering in non dom environments.
 */
export declare const RemirrorSSR: <Extension extends AnyExtension>(props: RemirrorSSRProps<Extension>) => JSX.Element;
