import { EditorState, Transaction } from '@remirror/core';
import { DirectEditorProps, EditorView } from '@remirror/pm/view';
/**
 * A mock editor view used only when prosemirror is running on the server
 */
export declare class EditorViewSSR {
    state: EditorState;
    dom: Element;
    dragging: null;
    root: Document | DocumentFragment;
    constructor(_place: Node | ((p: Node) => void) | {
        mount: Node;
    } | undefined, props: DirectEditorProps);
    update(_props: DirectEditorProps): void;
    setProps(_props: DirectEditorProps): void;
    updateState(_state: EditorState): void;
    someProps(_propName: string, f?: (prop: any) => any): any;
    hasFocus(): boolean;
    focus(): void;
    posAtCoords(_coords: {
        left: number;
        top: number;
    }): {
        pos: number;
        inside: number;
    } | null | undefined;
    coordsAtPos(_pos: number): {
        left: number;
        right: number;
        top: number;
        bottom: number;
    };
    domAtPos(_pos: number): {
        node: Node;
        offset: number;
    };
    nodeDOM(_pos: number): Node | null | undefined;
    posAtDOM(_node: Node, _offset: number, _bias?: number | null): number;
    endOfTextblock(_dir: 'up' | 'down' | 'left' | 'right' | 'forward' | 'backward', _state?: EditorState): boolean;
    /**
     * Removes the editor from the DOM and destroys all [node
     * views](#view.NodeView).
     */
    destroy(): void;
    dispatch(_tr: Transaction): void;
}
/**
 * Creates a new editor view
 *
 * @param place
 * @param props
 */
export declare function createEditorView(place: Node | ((p: HTMLElement) => void) | null, props: DirectEditorProps): EditorView;
